function sep_tracks = adding_NaN_in_missing_frames(tracks)
% Padding tracks so that the frame column is without gaps
% Author:
%   Yong Wang (c) Oct 2017
%
fprintf('sptPALM> padding tracks ...\n');
sep_tracks = [];
if size(tracks,1) < 1 %
    fprintf('sptPALM> the input <tracks> is empty! Cannot do padding.\n');
    return;
end

ntracks = max(tracks(:,4));
corrected_frm_num=1; % new frame num assigned to the beginning of each new trajectory

for i = 1:ntracks
    trk = tracks(tracks(:,4)==i,:);
    [frmin, jmin] = min(trk(:,3));
    [frmax, jmax] = max(trk(:,3));
    if jmin>1 || jmax<size(trk,1)
        fprintf('sptPALM> warning: it seems the tracks are not sorted!\n');    
    end
    n = (frmax-frmin+1);
    if n==size(trk,1) % no need to separate
        sep_tracks = [sep_tracks; trk];
    else % pad
        new_trk = NaN(n,4);
        new_trk(:,3)=frmin:frmax;
        new_trk(:,4)=trk(1,4);
        
        for j=1:n
           row=find(trk(:,3)==new_trk(j,3))
           if ~isnan(row)
               new_trk(j,:)=trk(row,:);
           end
                      
        end
        sep_tracks = [sep_tracks; new_trk];
    end    
end
fprintf('sptPALM> done with padding tracks.\n');
end