load('noInterP_result_tracking_400_min_3.txt', 'noInterP_result_tracking_400_min_3', '-ascii')

%osd_2D(result_tracking)
% this is to calculate one-step displacement from two continueous steps
% The 4th column of "onestep_MSD" is osd^2 values
data=noInterP_result_tracking_400_min_3;

%This m_file seperates particles according to their ID in the 'result_tracking', and
%calculates diffusion coeficient for each particle by fitting straight
%lines to the first 4 points of MSD/dt of the particle.
%of the tracking file and outputs the submatrices, e.g. sub_k is the
%submatrix of particle# k.
%load file
%make variable x y z frame number and particle ID

tic
x_p=data(:,1)/1000;
y_p=data(:,2)/1000;
z_p=data(:,2)/1000*0; % just null
frame=data(:,3); % updated for 2D input
particle=data(:,4); % updated for 2D input

d=length(particle); %total row number
ptotal=particle(d);%total particle number
tSteps=200;
onestep_MSD=[];
ave_MSD=[];
step_size=[];
k=1;
m=1;

%figure
for i=1:ptotal % i is particle ID, so per each particle (=trajectory)
    sel = find (data(:,4) == i); % updated for 2D
    trace = [x_p(sel,:) y_p(sel,:) z_p(sel,:) frame(sel,:)];
    [r,c]=size(trace);
    D=[];
    for j=1:r-1   %within the trajectory, calculate MSD      
        if trace(j+1,4)-trace(j,4)==1
            onestep_MSD(k,1:3)= trace(j,1:3);
            onestep_MSD(k,4)=(trace(j+1, 1)-trace(j,1))^2 + (trace(j+1, 2)-trace(j,2))^2+(trace(j+1, 3)-trace(j,3))^2;
            onestep_MSD(k,5)=i;
            D=[D; onestep_MSD(k,4)]; % D just saves all oneste_MSD values
            step_size(k,1)=sqrt((trace(j+1, 1)-trace(j,1))^2 + (trace(j+1, 2)-trace(j,2))^2+(trace(j+1, 3)-trace(j,3))^2);
            k=k+1;
        end  
    end
    
    % then for each particle, get the average MSD (still for one step)
    if isempty(D)==0
        ave_MSD(m,1) = mean(D);
        ave_MSD(m,2) = i; %particle ID
        m=m+1;
    end
    clear trace;
    clear D;
end

save ('onestep_MSD_list.dat', 'onestep_MSD', '-ascii');
save ('onestep_MSD_ave_list.dat', 'ave_MSD', '-ascii');
save ('step_size.dat', 'step_size', '-ascii');
clear
