function script(maxdisp_input, minlen)

%% load functions
addpath('\\desktop-lkqeepp\Data\SOURCE_CODES_backup\sptPALM_Wang');

%% get tracks
maxdisp = maxdisp_input;
param = struct();
param.mem = 1;
param.good = 0;
param.dim=2;
param.quiet=1;
sigma = 40;
%%%%%
if ~exist('fileName1','var')|| isempty(fileName1)
    [userfilein, userdirin]=uigetfile({
        '*.txt','Data file (*.txt)';...
        '*.*','All Files (*.*)'},'Select the PALM file to process',...
        'D:\mydocument\MATLAB\PALM_tracking_AnalysisCode');
    fileName1=fullfile(userdirin,userfilein);
else
    if ~exist(fileName1,'file')
        fprintf('File not found: %s\n',fileName1);
        return;
    end
end
%%%
locdata=load(fileName1);

%locdata = load('all_traces.txt');
xyf = locdata(:,[1,2,5]);
raw_tracks = sptPALM_track(xyf,maxdisp,param);
save('all_traces.txt','raw_tracks','-ascii');

%% remove short tracks and pad tracks
%minlen = 3
tracks = load('all_traces.txt');
tracks = sptPALM_remove_short_tracks(tracks, minlen);

track_result     = sprintf('noInterP_result_tracking_%d_min_%d.txt',maxdisp, minlen);
save(track_result,'tracks','-ascii');


tracks = sptPALM_pad_tracks(tracks);
track_result     = sprintf('result_tracking_%d_min_%d.txt',maxdisp, minlen);
save(track_result,'tracks','-ascii');

%% plot tracks
%figure
sptPALM_plot_tracks(tracks,0);
drawnow();
track_plot     = sprintf('%d_%d_%d_min_%d.fig',param.mem, param.good,...
                                                       maxdisp, minlen);
%track_plot_jpg  = sprintf('%d_%d_%d_min_%d.jpg',param.mem, param.good,...
%                                                       maxdisp, minlen);

savefig(track_plot)
%saveas(gcf, track_plot_jpg)
%%
nt = max(tracks(:,4));
len=[];
for i=1:nt
    len = [len; length(tracks(tracks(:,4)==i,1))];
end
figure(2);clf;
hist(len,20)
track_hist     = sprintf('%d_%d_%d_min_%d_hist.fig',param.mem, param.good,...
                                                       maxdisp, minlen);
savefig(track_hist)

clear

end
