function msds = sptPALM_calc_msds(tracks, dt)
% function msds = sptPALM_calc_msds(tracks, dt)
% calc MSDs from tracks.
% 
%
% Author:
%   Yong Wang (c) Oct 2017
msds = [];
if size(tracks,1)<1
    fprintf('sptPALM> tracks are empty! skipping plot.\n');
    return;
end
fprintf('sptPALM> calculating MSDs ...\n');
ntracks = max(tracks(:,4));
for i = 1:ntracks
    trk = tracks(tracks(:,4)==i,:);
    [tau, msd] = sptPALM_calc_single_msd(trk, dt);
    n = length(msd);
    res = [reshape(tau,[],1), reshape(msd,[],1), ones(n,1)*i];
    msds = [msds; res];
end
fprintf('sptPALM> done with calculating MSDs ...\n');