function [tau, msd] = sptPALM_calc_single_msd(single_track, dt)
% (x,y,f,tid)
% calculate msd for a single track
% Author:
%   Yong Wang (c) Oct 2017
%
if ~exist('dt','var')
    dt = 1.0;
end

x = single_track(:,1);
y = single_track(:,2);
n = length(x);
tau = zeros(n,1);
msd = zeros(n,1);
for i=1:n-1
    tau(i+1) = i*dt;
    dx = x(1+i:n)-x(1:n-i);
    dy = y(1+i:n)-y(1:n-i);
    dr2 = dx.^2 + dy.^2;
    msd(i+1) = mean(dr2(:));
end
end