function goodtracks = sptPALM_double_check_track_mem(tracks, mem)
% Remove short tracks with a large mem
%
% Author:
%   Yong Wang (c) Oct 2017

goodtracks = [];
fprintf('sptPALM> removing tracks with large mem ...\n');
ntracks = max(tracks(:,4));
cnt = 0;
for i = 1:ntracks
    trk = tracks(tracks(:,4)==i, :);
    dt = diff(trk(:,3));
    if max(dt) <= mem+1
        cnt = cnt + 1;
        trk(:,4) = cnt;
        goodtracks = [goodtracks; trk];
    end
end
fprintf('sptPALM> done: %d/%d tracks are left.\n', cnt,ntracks);
if cnt<1
    fprintf('sptPALM> warning: no tracks are left. Consider to change the mem parameter.\n');
end
end

