function h = sptPALM_plot_tracks(tracks, shift)
% function: plot tracks
% optional parameter: shift - flag to indicate whether shifting to origin
% Author:
%   Yong Wang (c) Oct 2017
if ~exist('shift','var')
    shift = 0;
end

h = figure(); clf;
if size(tracks,1)<1
    fprintf('sptPALM> tracks are empty! skipping plot.\n');
    return;
end
ntracks = max(tracks(:,4));
fprintf('sptPALM> plotting %d tracks (shift=%d)...\n', ntracks, shift~=0);
for i = 1:ntracks
    trk = tracks(tracks(:,4)==i, :);
    if shift
        fr = trk(:,3);
        [fr_min, j_min] = min(fr);
        if j_min > 1
            fprintf('sptPALM> warning: it seems that the tracks are NOT sorted!');
        end
        x0 = trk(j_min,1);
        y0 = trk(j_min,2);
        trk(:,1) = trk(:,1)-x0;
        trk(:,2) = trk(:,2)-y0;
    end
    plot(trk(:,1), trk(:,2),'-');
    hold on;
end
axis equal;
axis tight;
xlabel('X (nm)');
ylabel('Y (nm)');

