function goodtracks = sptPALM_remove_short_tracks(tracks, min_length)
% Remove short tracks with a length below the given value (min_length)
%
% Author:
%   Yong Wang (c) Oct 2017

goodtracks = [];
fprintf('sptPALM> removing short tracks ...\n');
ntracks = max(tracks(:,4));
cnt = 0;
for i = 1:ntracks
    trk = tracks(tracks(:,4)==i, :);
    if size(trk,1) >= min_length
        cnt = cnt + 1;
        trk(:,4) = cnt;
        goodtracks = [goodtracks; trk];
    end
end
fprintf('sptPALM> done: %d tracks are left.\n', cnt);
if cnt<1
    fprintf('sptPALM> warning: no tracks are left. Consider to change the min_length parameter.\n');
end
end

